## ros-galactic-control-toolbox 2.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(control_toolbox)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(WIN32)
  # Enable Math Constants
  # https://docs.microsoft.com/en-us/cpp/c-runtime-library/math-constants?view=vs-2019
  add_compile_definitions(
    _USE_MATH_DEFINES
  )
endif()

find_package(ament_cmake REQUIRED)
find_package(control_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcutils REQUIRED)
find_package(realtime_tools REQUIRED)

add_library(${PROJECT_NAME} SHARED
  src/dither.cpp
  src/limited_proxy.cpp
  src/pid_ros.cpp
  src/pid.cpp
  src/sine_sweep.cpp
  src/sinusoid.cpp)
target_include_directories(${PROJECT_NAME} PUBLIC include)
target_compile_definitions(${PROJECT_NAME} PRIVATE "CONTROL_TOOLBOX_BUILDING_LIBRARY")
ament_target_dependencies(${PROJECT_NAME}
    control_msgs
    rclcpp
    rcutils
    realtime_tools)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(rclcpp_lifecycle REQUIRED)

  ament_add_gmock(pid_tests test/pid_tests.cpp)
  target_link_libraries(pid_tests ${PROJECT_NAME})

  ament_add_gtest(pid_parameters_tests test/pid_parameters_tests.cpp)
  target_link_libraries(pid_parameters_tests ${PROJECT_NAME})

  ament_add_gtest(pid_publisher_tests test/pid_publisher_tests.cpp)
  target_link_libraries(pid_publisher_tests ${PROJECT_NAME})
  ament_target_dependencies(pid_publisher_tests rclcpp_lifecycle)
endif()

# Install
install(DIRECTORY include/
  DESTINATION include)

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

ament_export_dependencies(
  control_msgs
  rclcpp
  rcutils
  realtime_tools)
ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})

ament_package()

=== debian/changelog ===
ros-galactic-control-toolbox (2.1.2-1focal) focal; urgency=high

  * export missing dependency (#128 <https://github.com/ros-controls/control_toolbox/issues/128>)
  * Contributors: Noel Jiménez García

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Tue, 15 Nov 2022 00:00:00 -0000

ros-galactic-control-toolbox (2.1.1-1focal) focal; urgency=high

  * Add declaration of parameters in ROSPid.
  * Fix namespace collision and parameter_callback problems in PidROS
  * Contributors: Aris Synodinos, Denis Štogl

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Nov 2022 00:00:00 -0000

ros-galactic-control-toolbox (2.1.0-1focal) focal; urgency=high

  * Fix parameter loading log levels
  * Support pass in a precomputed derivative error
  * Add getParametersCallbackHandle function
  * Add topic_prefix_ to declareParam & setParameter
  * Update include/control_toolbox/dither.hpp
  * Correct contributing and license files for ament_copyright.
  * Added license text file and contributing guidelines, corrected license short identifier.
  * Remove build of downstream workspace.
  * Update CI config and add pre-commit-config.
  * Contributors: Bence Magyar, ChenJun, Denis Štogl, Timon Engelke

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Jun 2022 23:00:00 -0000

ros-galactic-control-toolbox (2.0.2-1focal) focal; urgency=high

  * remove unused variables
  * Update visibility_control.hpp
  * Windows bringup.
  * Contributors: Karsten Knese, Sean Yen, Bence Magyar

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 May 2021 23:00:00 -0000

ros-galactic-control-toolbox (2.0.1-1focal) focal; urgency=high

  * Fix dependencies
  * Export ament_cmake build type
  * Contributors: ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Jul 2020 23:00:00 -0000

ros-galactic-control-toolbox (2.0.0-1focal) focal; urgency=high

  * Refactor the Pid class to be completely ROS agnostic and added a ROS 2 wrapper
  * Avoid crash when the type of the parameter doesn't match
  * Added topic_prefix to publisher topic name (#95 <https://github.com/ros-controls/control_toolbox/issues/95>)
  * Created a shared library (#93 <https://github.com/ros-controls/control_toolbox/issues/93>)
  * Aliases not part of the public API are now private
  * Removing pid_gains_setter
  * Removed unnecessary dependencies
  * Cleared empty non virtual destructors
  * Removed unused limited proxy variables
  * Added pid state real-time publisher
  * Removed all references to tinyxml
  * Removed tune_pid.py
  * Adding missing copyright licenses
  * Adapted dither, sine_sweep and sinusoid to ROS2
  * Removed dynamic reconfigure completely
  * Removed deprecated functions
  * Contributors: Alejandro Hernández Cordero, Bence Magyar, James Xu, Jordan Palacios, Shane Loretz, ahcorde

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jul 2020 23:00:00 -0000

ros-galactic-control-toolbox (1.17.0-1focal) focal; urgency=high

  * update anti windup clamping
  * update negativeIntegrationAntiwindupTest
  * Address catkin_lint issues
  * Add executable flag
  * convert to package xml format 2
  * Remove doc header
  * Contributors: Bence Magyar, Cong, Gennaro Raiola

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 31 Jan 2019 00:00:00 -0000

ros-galactic-control-toolbox (1.16.0-1focal) focal; urgency=high

  * switched to industrial_ci
  * Add control_msgs to CATKIN_DEPENDS.
  * Contributors: Bence Magyar, Mathias Luedtke, Mike Purvis

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 30 Nov 2017 00:00:00 -0000

ros-galactic-control-toolbox (1.15.0-1focal) focal; urgency=high

  * avoid ABI breaks in PID class
  * fix add_dependencies call
  * rollback API changes in PID class
  * cfg: removed rosbuild support related error handling
  * Contributors: Bence Magyar, Igor Napolskikh, ipa-mig

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jun 2016 23:00:00 -0000

ros-galactic-control-toolbox (1.14.0-1focal) focal; urgency=high

  * Fix negative gains issue and add tests; update gains setting through DynamicReconfig
  * Add antiwindup and tests to PID controller; rename old behaviour 'clamping'
  * Move message to control_toolbox
  * Add optional state publishing to PID controller, for logging/debugging/etc
  * Fix some typos in comments
  * changed the range of dynamic reconfigure to allow negative ones
  * Address -Wunused-parameter warnings
  * Factor out updatePid as negative calls to computeCommand
  * Increasing covergae of PID class test suite.
  * Chain calls of computeCommand and updatePid for code reuse
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Bence Magyar, Carlos Rosales, Guillaume Walck, Paul Bovbel, VahidAminZ

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 02 May 2016 23:00:00 -0000

ros-galactic-control-toolbox (1.13.2-1focal) focal; urgency=high

  * CRITICAL BUGFIX: Fix broken PID command computation.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Paul Bovbel

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 21 May 2015 23:00:00 -0000

ros-galactic-control-toolbox (1.13.1-1focal) focal; urgency=high

  * Improvement in integral contribution implementation. Resolve #32 <https://github.com/ros-controls/control_toolbox/issues/32>.
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Carlos Rosales

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 29 Apr 2015 23:00:00 -0000

ros-galactic-control-toolbox (1.13.0-1focal) focal; urgency=high

  * Harmonize pid gain names between rosparam and dynamic_reconfigure
  * Read i_clamp_min and i_clamp_max form parameter server - if available
  * Contributors: Adolfo Rodriguez Tsouroukdissian, Dave Coleman, ipa-fxm

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 31 Oct 2014 00:00:00 -0000

ros-galactic-control-toolbox (1.12.1-1focal) focal; urgency=high

  * Remove broken test code. Hotfix for #18 <https://github.com/ros-controls/control_toolbox/issues/18>.


=== debian/control ===
Source: ros-galactic-control-toolbox
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gmock, ros-galactic-ament-cmake-gtest, ros-galactic-control-msgs, ros-galactic-rclcpp, ros-galactic-rclcpp-lifecycle, ros-galactic-rcutils, ros-galactic-realtime-tools, ros-galactic-ros-workspace
Homepage: http://ros.org/wiki/control_toolbox
Standards-Version: 3.9.2

Package: ros-galactic-control-toolbox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-control-msgs, ros-galactic-rclcpp, ros-galactic-rcutils, ros-galactic-realtime-tools, ros-galactic-ros-workspace
Description: The control toolbox contains modules that are useful across all controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-control-toolbox//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
